# KQueens

# How To Run:
- `stack build`
  - If you want multithreading: `stack build --ghc-options -threaded`
- `stack run [board dimension] [maximum depth]`
  - If you want to generate event log for threadscope and run with 6 cores: `./.stack-work/install/aarch64-osx/65b9e3269ee0baf00e62265284d6b507a0182ce30979996765728ea77d0a1e3a/9.8.4/bin/KQueens-exe +RTS -N6 -s -ls`

Or to build and execute in one
- `stack run [board dimension] [maximum depth] -- +RTS -N6 -s -ls`
  - Note maximum depth must be less than the square of board dimension (number of grid elements)


## Other useful commands to know:
- `stack install` will just do `stack build` with `--copy-bins` flag (aka, it will copy the executable to `~/.local/bin`)
